# Sealed Secrets Background

Big-picture explanations of higher-level Sealed Secrets concepts. Most useful for building understanding of a particular topic.

| Background                                         | Description                                                                                      |
| -------------------------------------------------- | ------------------------------------------------------------------------------------------------ |
| [Cryptography](./cryptography.md)                  | Dive into the overall Sealed Secrets Cryptography.                                                     |

Alternatively, if you have a specific goal, but are already familiar with Sealed Secrets, take a look at our [How-to guides](../howto/README.md). These have more in-depth detail and can be applied to a broader set of features.

Take a look at our [Reference section](../reference/README.md) when you need to know design decisions, detailed developer guides, etc.

Finally, our [Tutorials section](../tutorials/README.md) contains step-by-step tutorials to help outline what Sealed Secrets is capable of.
